<?php

namespace App\Models;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Carbon\Carbon;
 
class Post extends Model
{ 
     use HasFactory;
    
    /*
     * The table associated with the model.
     */
    protected $table = 'posts';
  
    
   /**
     * The attributes that are mass assignable.
     * @var array<int, string>
     */
    protected $guarded = []; 
    
    
    
    public static function getDate($existingDate){
        
        $date = Carbon::parse($existingDate);
        $formattedDate = $date->copy()->locale($lang)->translatedFormat('d-m-y');
        return $formattedDate;
            
    }
    
    
     public static function getYear(){
        
        $existingDate = $this->created_at;
        $date = Carbon::parse($existingDate);
        $formattedDate = $date->copy()->locale($lang)->translatedFormat('Y');
        return $formattedDate;
            
    }
    
      public static function getMonth($existingDate){
        
        $date = Carbon::parse($existingDate);
        return $date->copy()->locale($lang)->translatedFormat('M');
            
    }
    
    
    public static function getDay($existingDate){
        
        $date = Carbon::parse($existingDate);
        $formattedDate = $date->copy()->locale($lang)->translatedFormat('d');
        return $formattedDate;
            
    }
    
    
    public static function getTime($existingDate){
        
        $date = Carbon::parse($existingDate);
        $formattedDate = $date->copy()->locale($lang)->translatedFormat('d M Y');
        $relativeTime = $date->diffForHumans([
            'parts' => 1,
            'short' => true,
        ]);
        return $relativeTime;
    }
    
    

}

?>